package net.tomatentum.cutin.container;

import java.lang.reflect.Method;
import java.util.Collection;
import java.util.Optional;
import java.util.Set;

import net.tomatentum.cutin.ReflectedMethod;

public interface MethodContainer<I extends Object> {

    MethodContainer<I> addMethod(ReflectedMethod<I> method);
    default MethodContainer<I> addMethods(ReflectedMethod<I>[] methods) {
        for (ReflectedMethod<I> reflectedMethod : methods) {
            this.addMethod(reflectedMethod);
        }
        return this;
    }
    MethodContainer<I> addMethods(Object containingObject, Method... methods);
    default MethodContainer<I> addAllMethods(Object containingObject) {
        this.addMethods(containingObject, containingObject.getClass().getDeclaredMethods());
        return this;
    }

    Set<I> identifiers();
    Collection<ReflectedMethod<I>> methods();
    Collection<ReflectedMethod<I>> findFor(I identifier);
    Optional<ReflectedMethod<I>> findFirstFor(I identifier);
    
}
